open Objets_graphiques;;
open List;;

type t_construction_list = (t_objet_graphique ref) list;;

let rec ajouter_objet obj l =
  match l with
    | [] -> [obj]
    | (t::q) -> t::(ajouter_objet obj q);;

let dependances f x = (* f : methode renvoyant le flag *)
    (* Vrai si un parametre de x est marque *)
    (filter f (!x)#dependance) <> [];;
  
let marque_elts_liste f g z = 
  (* f : methode renvoyant le flag *)
  (* g : methode mettant le flag  vrai *)
  if (dependances f z) then g z else ();;
      
let enlever_objet obj liste =
  !obj#marque_a_supprimer;
  let rec depoussiere l =
    match l with
      | [] -> []
      | (t::q) ->
	  if (!t)#est_a_supprimer
	  then depoussiere q
	  else t::(depoussiere q)
  in
    iter (marque_elts_liste
	    (function x -> !x#est_a_supprimer)
	    (function x -> !x#marque_a_supprimer)) liste;
    depoussiere liste;;


let bouger_objet obj rep c liste =
  (!obj)#deplace_objet;
  (!obj)#bouge rep c;
  let balayette x =
    marque_elts_liste
      (function y -> !y#objet_deplace)
      (function y -> !y#deplace_objet) x;
    if (!x)#objet_deplace then (!x)#recalcule
  in
    iter balayette liste;;

let objets_proches rep c l =
  filter (function x -> (!x)#est_proche rep c) l;;

let points_proches rep c l =
  filter (function x -> !x#objet_type = TYPE_POINT)
    (objets_proches rep c l);;

let droites_proches rep c l =
  filter (function x -> !x#objet_type = TYPE_DROITE)
    (objets_proches rep c l);;

let redessine win rep l =
  iter (function x -> (!x)#dessine win rep) l;;

  
