exception Bizarre

type t_coords = {mutable x : float; mutable y : float};;

type t_coords_int = {mutable xint : int; mutable yint : int};;

type t_equation_droite = {mutable origx : float;
			  mutable origy : float;
			  mutable dirx : float;
			  mutable diry : float};;

type t_equation_cercle = {mutable centrex : float;
			  mutable centrey : float;
			  mutable rayon : float};;

type t_equation =
  | DROITE of t_equation_droite
  | CERCLE of t_equation_cercle;;

type t_repere =
    {mutable xo : float;
     mutable yo : float;
     mutable xi : float;
     mutable yj : float};;

val largeur_ecran : int;;
val hauteur_ecran : int;;
val pixels_proche : int;;

val papier_vers_ecran : t_repere -> t_coords -> t_coords_int;;
val ecran_vers_papier : t_repere -> t_coords_int -> t_coords;;

val distance_vers_papier : t_repere -> int -> float;;
val distance_vers_ecran : t_repere -> float -> int;;

val coin_sud_ouest : t_repere -> t_coords;;
val coin_nord_est : t_repere -> t_coords;;

val x_min_ecran : t_repere -> float;;
val x_max_ecran : t_repere -> float;;
val y_min_ecran : t_repere -> float;;
val y_max_ecran : t_repere -> float;;

val solution_equation :
  float -> float -> float -> float -> float -> float -> t_coords;;
