open Gdk
open GDraw
open GMain

class fenetre_principale () =
  let window =
    GWindow.window ~title:"Drgeocaml" ~allow_shrink:true ~allow_grow:true
      ~auto_shrink:true ~modal:true ()
  in
  let vbox = GPack.vbox ~homogeneous:false ~packing:window#add () in
  let mbarprincipale =
    GMenu.menu_bar ~packing:(vbox#pack ~expand:false ~fill:true) ()
  in
  let itemfile =
    GMenu.menu_item ~label:"File" ~packing:mbarprincipale#add ()
  in
  let menufile = GMenu.menu ~packing:itemfile#set_submenu () in
  let itemquit = GMenu.menu_item ~label:"Quit" ~packing:menufile#add () in
  let itempoints =
    GMenu.menu_item ~label:"Points" ~packing:mbarprincipale#add ()
  in
  let menupoints = GMenu.menu ~packing:itempoints#set_submenu () in
  let itempointclique =
    GMenu.menu_item ~label:"Point libre" ~packing:menupoints#add ()
  in
  let itemlignes =
    GMenu.menu_item ~label:"Lignes" ~packing:mbarprincipale#add ()
  in
  let menulignes = GMenu.menu ~packing:itemlignes#set_submenu () in
  let itemdroitedeuxpoints =
    GMenu.menu_item ~label:"Droitepoints" ~packing:menulignes#add ()
  in
  let accelgroup = GtkData.AccelGroup.create () in
  let _ = menufile#set_accel_group accelgroup in
  let _ =
    itemquit#add_accelerator ~group:accelgroup ~modi:([`CONTROL])
      ~flags:([`VISIBLE; `LOCKED]) GdkKeysyms._Q
  in
  let _ = menupoints#set_accel_group accelgroup in
  let _ =
    itempointclique#add_accelerator ~group:accelgroup ~modi:([`CONTROL])
      ~flags:([`VISIBLE; `LOCKED]) GdkKeysyms._P
  in
  let _ = menulignes#set_accel_group accelgroup in
  let _ =
    itemdroitedeuxpoints#add_accelerator ~group:accelgroup ~modi:([`CONTROL])
      ~flags:([`VISIBLE; `LOCKED]) GdkKeysyms._D
  in
  let area =
    GMisc.drawing_area ~width:800 ~height:600
      ~packing:(vbox#pack ~expand:false ~fill:true) ()
  in
  object
    val window = window
    val vbox = vbox
    val mbarprincipale = mbarprincipale
    val accelgroup = accelgroup
    val itemfile = itemfile
    val menufile = menufile
    val itemquit = itemquit
    val itempoints = itempoints
    val menupoints = menupoints
    val itempointclique = itempointclique
    val itemlignes = itemlignes
    val menulignes = menulignes
    val itemdroitedeuxpoints = itemdroitedeuxpoints
    val area = area
    method window = window
    method vbox = vbox
    method mbarprincipale = mbarprincipale
    method accelgroup = accelgroup
    method itemfile = itemfile
    method menufile = menufile
    method itemquit = itemquit
    method itempoints = itempoints
    method menupoints = menupoints
    method itempointclique = itempointclique
    method itemlignes = itemlignes
    method menulignes = menulignes
    method itemdroitedeuxpoints = itemdroitedeuxpoints
    method area = area
  end;;
