open Fonctions;;

exception Erreur of string;;

type t_type_objet =
  | TYPE_AUCUN
  | TYPE_POINT
  | TYPE_DROITE
  | TYPE_VECTEUR
  | TYPE_CERCLE
  | TYPE_REPERE;;

type style_point =
  | CROIX
  | ROND;;

type style_droite =
  | PLEINE
  | POINTILLEE;;

type style_objet =
  | BLOP
  | STYLE_POINT of style_point
  | STYLE_DROITE of style_droite;;

type t_donnees_objet =
    {mutable coords : t_coords list; mutable equation : t_equation list};;

class type virtual t_objet_graphique = object
  method objet_nom : string
  method nomme : string -> unit
  method objet_couleur : GDraw.color
  method change_couleur : GDraw.color -> unit
  method objet_visible : bool
  method montre_objet : unit
  method cache_objet : unit
  method objet_calculable : bool
  method rend_calculable : unit
  method rend_incalculable : unit
  method objet_epaisseur : int
  method change_epaisseur : int -> unit
  method objet_deplace : bool
  method deplace_objet : unit
  method fixe_objet : unit
  method marque_a_supprimer : unit
  method est_a_supprimer : bool
  method change_style : style_objet -> unit
  method parametres : t_donnees_objet
  method change_parametres : t_donnees_objet -> unit
				       
  method virtual objet_type : t_type_objet
  method virtual dessine : [ `window] GDraw.drawable -> t_repere -> unit
  method virtual est_proche : t_repere -> t_coords_int -> bool
  method virtual recalcule : unit
  method virtual depend_de : t_objet_graphique ref -> bool
  method virtual dependance : t_objet_graphique ref list
  method virtual bouge : t_repere -> t_coords_int -> unit
end

class virtual objet_graphique : t_objet_graphique;;

val premieres_coordonnees_point_objet :
  t_objet_graphique ref -> t_coords;;
val secondes_coordonnees_point_objet :
  t_objet_graphique ref -> t_coords;;
val premieres_coordonnees_second_point :
  t_objet_graphique ref list -> t_coords;;
val premiere_equation_droite_objet :
  t_objet_graphique ref -> t_equation_droite;;
