open Objets_graphiques;;
open List;;
open Graphx;;
open Fonctions;;

class type virtual t_objet_point =
object 
  inherit t_objet_graphique
  method est_proche : t_repere -> t_coords_int -> bool
  method dessine : [ `window] GDraw.drawable -> t_repere -> unit
  method parametres : t_donnees_objet
  method objet_type : t_type_objet
end;;

class virtual objet_point =
object (self)
  inherit objet_graphique
  val mutable style = STYLE_POINT (CROIX)

  method est_proche rep c =
    let u = papier_vers_ecran rep (hd self#parametres.coords) in
    let deltax = u.xint - c.xint and deltay = u.yint - c.yint in
      (deltax * deltax + deltay * deltay <= pixels_proche)

  method dessine win rep =
    let dessine_point c =
      begin
	print_string "procdure point appele";
	print_newline ();
	win#set_foreground self#objet_couleur;
	win#set_line_attributes ~width: self#objet_epaisseur ();
	match style with
	  | STYLE_POINT (CROIX) ->
	      win#line (c.xint + 3) (c.yint + 3) (c.xint - 3) (c.yint - 3);
	      win#line (c.xint - 3) (c.yint + 3) (c.xint + 3) (c.yint - 3)
	  | _ -> raise Bizarre
      end
    in
      dessine_point (papier_vers_ecran rep (hd self#parametres.coords))

  method objet_type = TYPE_POINT
end;;


